//addsvgiconPlugin  ver.0.00
//(c)Beer[Tsutsumi Hiroyuki]  2005.1.5

#include	<Be.h>
#include	<MProject.h>
#include	<MPlugInPrefsView.h>
#include	<MPlugInBuilder.h>

class addsvgiconPIV:public MPlugInPrefsView
{
	public:
		addsvgiconPIV(BRect inFrame);
//		void		AttachedToWindow();
		void		Draw(BRect updateRect);
		const char*	Title();
		TargetT		Targets();
		void		GetData(BMessage &inOutMessage);
		void		SetData(BMessage &inOutMessage);
		void		GetPointers(void *&outOld,void *&outNew,long &outLength);
		void		DoSave();
		void		DoRevert();
		void		DoFactorySettings();
		void		UpdateValues();
		void		ValueChanged();
		bool		FilterKeyDown(ulong aKey);
		bool		ProjectRequiresUpdate(UpdateType inType);
	private:
		BBox	*bb;
};
//----------
class addsvgiconPIB:public MPlugInBuilder
{
	public:
		addsvgiconPIB();
		status_t	GetToolName(MProject *inProject,char *outName,int32 inBufferLength,MakeStageT inStage,MakeActionT inAction);
		const char*	LinkerName();
		MakeStageT	MakeStages();
		MakeActionT	Actions();
		PlugInFlagsT	Flags();
		ulong		MessageDataType();
		bool		ValidateSettings(BMessage &inOutMessage);
		status_t	BuildPrecompileArgv(MProject &inProject,BList &inArgv,MFileRec &inFileRec);
		status_t	BuildCompileArgv(MProject &inProject,BList &inArgv,MakeActionT inAction,MFileRec &inFileRec);
		status_t	BuildPostLinkArgv(MProject &inProject,BList &inArgv,MFileRec &inFileRec);
		bool		FileIsDirty(MProject &inProject,MFileRec &inFileRec,MakeStageT inStage,MakeActionT inAction,time_t inModDate);
		status_t	ParseMessageText(MProject &inProject,const char *inText,BList &outList);
		void		CodeDataSize(MProject &inProject,const char *inFilePath,int32 &outCodeSize,int32 &outDataSize);
		status_t	GenerateDependencies(MProject &inProject,const char *inFilePath,BList &outList);
		void		GetTargetFilePaths(MProject &inProject,MFileRec &inFileRec,BList &inOutTargetFileList);
		void		ProjectChanged(MProject &inProject,ChangeT inChange);
};
//==========
addsvgiconPIV::addsvgiconPIV(BRect inFrame):MPlugInPrefsView(inFrame,"addatrview",B_WILL_DRAW,0)
{
	bb=new BBox(Bounds(),"addsvgiconBB",0,B_WILL_DRAW,B_FANCY_BORDER);
	bb->SetLabel("Add SVG Icon Tool");
	AddChild(bb);
}

void addsvgiconPIV::Draw(BRect updateRect)
{
	bb->SetLowColor(kPrefsGray);
	bb->SetViewColor(kPrefsGray);
}

const char* addsvgiconPIV::Title()
{
	static char	s[]="addsvgicon";
	return(s);
}
TargetT addsvgiconPIV::Targets()
{
	return(kMWDefaults|kCurrentProject);
}
void addsvgiconPIV::GetData(BMessage &inOutMessage)
{
}
void addsvgiconPIV::SetData(BMessage &inOutMessage)
{
}
void addsvgiconPIV::GetPointers(void *&outOld,void *&outNew,long &outLength)
{
}
void addsvgiconPIV::DoSave()
{
}
void addsvgiconPIV::DoRevert()
{
}
void addsvgiconPIV::DoFactorySettings()
{
}
void addsvgiconPIV::UpdateValues()
{
}
void addsvgiconPIV::ValueChanged()
{
}
bool addsvgiconPIV::FilterKeyDown(ulong aKey)
{
	bool	b;
	b=false;
	return(b);
}
bool addsvgiconPIV::ProjectRequiresUpdate(UpdateType inType)
{
	bool	b;
	b=false;
	return(b);
}
//----------
addsvgiconPIB::addsvgiconPIB()
{
}
status_t addsvgiconPIB::GetToolName(MProject *inProject,char *outName,int32 inBufferLength,MakeStageT inStage,MakeActionT inAction)
{
	strcpy(outName,"/boot/apps/Development/BeIDE/tools/addsvgicon");
	return(B_OK);
}
const char* addsvgiconPIB::LinkerName()
{
	static char	s[]="addsvgicon";
	return(s);
}
MakeStageT addsvgiconPIB::MakeStages()
{
	return(kPostLinkStage);
}
MakeActionT addsvgiconPIB::Actions()
{
	return(kPostLinkExecute);
}
PlugInFlagsT addsvgiconPIB::Flags()
{
	return(kNotIDEAware);
}
ulong addsvgiconPIB::MessageDataType()
{
	return(0);
}
bool addsvgiconPIB::ValidateSettings(BMessage &inOutMessage)
{
	return(false);
}
status_t addsvgiconPIB::BuildPrecompileArgv(MProject &inProject,BList &inArgv,MFileRec &inFileRec)
{
	return(B_ERROR);
}
status_t addsvgiconPIB::BuildCompileArgv(MProject &inProject,BList &inArgv,MakeActionT inAction,MFileRec &inFileRec)
{
	return(B_ERROR);
}
status_t addsvgiconPIB::BuildPostLinkArgv(MProject &inProject,BList &inArgv,MFileRec &inFileRec)
{
	entry_ref	ex;
	inProject.GetExecutableRef(ex);
	BPath	p(&ex);
	char	*s;
	s=new char[256];
	strcpy(s,inFileRec.path);
	inArgv.AddItem(s);
	s=new char[256];
	strcpy(s,p.Path());
	inArgv.AddItem(s);
	return(B_NO_ERROR);
}
bool addsvgiconPIB::FileIsDirty(MProject &inProject,MFileRec &inFileRec,MakeStageT inStage,MakeActionT inAction,time_t inModDate)
{
	return(false);
}
status_t addsvgiconPIB::ParseMessageText(MProject &inProject,const char *inText,BList &outList)
{
	return(B_ERROR);
}
void addsvgiconPIB::CodeDataSize(MProject &inProject,const char *inFilePath,int32 &outCodeSize,int32 &outDataSize)
{
}
status_t addsvgiconPIB::GenerateDependencies(MProject &inProject,const char *inFilePath,BList &outList)
{
	return(B_ERROR);
}
void addsvgiconPIB::GetTargetFilePaths(MProject &inProject,MFileRec &inFileRec,BList &inOutTargetFileList)
{
}
void addsvgiconPIB::ProjectChanged(MProject &inProject,ChangeT inChange)
{
}
//==========
extern "C" status_t MakeAddOnView(int32 inIndex, BRect inRect, MPlugInPrefsView*& outView);
extern "C" status_t MakeAddOnBuilder(int32 inIndex, MPlugInBuilder*& outBuilder);
//extern "C" status_t MakeAddOnLinker(MPlugInLinker*& outLinker);

status_t MakeAddOnView(int32 inIndex, BRect inRect, MPlugInPrefsView*& outView)
{
	status_t	stt;
	if(inIndex==0){
		outView=(MPlugInPrefsView*)new addsvgiconPIV(inRect);
		stt=B_OK;
	}else{
		stt=B_ERROR;
	}
	return(stt);
}

status_t MakeAddOnBuilder(int32 inIndex, MPlugInBuilder*& outBuilder)
{
	status_t	stt;
	if(inIndex==0){
		outBuilder=(MPlugInBuilder*)new addsvgiconPIB();
		stt=B_OK;
	}else{
		stt=B_ERROR;
	}
	return(stt);
}

/*
status_t MakeAddOnLinker(MPlugInLinker*& outLinker)
{
	status_t	stt;
	return(stt);
}
*/
