// mode: -*- C++ -*-
#ifndef PCXIMAGE_H
#define PCXIMAGE_H

#include "SDL.h"
#include "imageproc.h"

class VFile;

struct PCXHeader
{

    Uint8	Signature;
    Uint8	Version;
    Uint8	Encoding;
    Uint8	BitsPixel;
    Uint16	XMin;
    Uint16	YMin;
    Uint16	XMax;
    Uint16	YMax;
    Uint16	HRes;
    Uint16	VRes;
    SDL_Color palette[16];
    Uint8	Reserved;
    Uint8	NumPlanes;
    Uint16	BytesLine;
    Uint16	PalType;		// 1 = Color or s/w, 2 = Black and white
    Uint16	HscreenSize;
    Uint16	VscreenSize;
    Uint8	Dummy[58];
};

class PCXImage
{
public:
    PCXImage(const char* fname, int scaleq);
    ~PCXImage();
    SDL_Surface* getImage();
private:
    void loadImage();
    void readPalette();
    Uint32 imgsize;
    Uint8* pcxdata;
    SDL_Color palette[256 ];
    PCXHeader header;
    int scaleq;
    ImageProc scaler;
    SDL_Surface* image;
	bool Use16ColorPalette,
		HeaderError;
};

#endif
